program TweetVoice;

{$RTTI EXPLICIT METHODS([]) FIELDS([]) PROPERTIES([])}

uses
  Windows,
  Forms,
  tvFormMain in '..\UI\tvFormMain.pas' { FormMainTweetVoice },
  tvXMLBase in '..\XML\tvXMLBase.pas',
  tvUserConfig in '..\Misc\tvUserConfig.pas',
  GpStreamWrapper in '..\..\components\OmniXML\GpStreamWrapper.pas',
  GpTextStream in '..\..\components\OmniXML\GpTextStream.pas',
  OmniXML in '..\..\components\OmniXML\OmniXML.pas',
  OmniXML_Dictionary in '..\..\components\OmniXML\OmniXML_Dictionary.pas',
  OmniXML_LookupTables in '..\..\components\OmniXML\OmniXML_LookupTables.pas',
  OmniXML_Types in '..\..\components\OmniXML\OmniXML_Types.pas',
  OmniXMLPersistent in '..\..\components\OmniXML\OmniXMLPersistent.pas',
  OmniXMLProperties in '..\..\components\OmniXML\OmniXMLProperties.pas',
  OmniXMLUtils in '..\..\components\OmniXML\OmniXMLUtils.pas',
  OmniXMLXPath in '..\..\components\OmniXML\OmniXMLXPath.pas',
  tvFormOptions in '..\UI\tvFormOptions.pas' { FormOptions },
  tvXMLUserManager in '..\XML\tvXMLUserManager.pas',
  tvImageDownloader in '..\Net\tvImageDownloader.pas',
  tvCommunicator in '..\Net\tvCommunicator.pas',
  utThreadQueue in '..\..\Utils\utThreadQueue.pas',
  utFunctions in '..\..\Utils\utFunctions.pas',
  SpeechLib_TLB in '..\..\Imports\SpeechLib_TLB.pas',
  tvSpeechThread in '..\Speech\tvSpeechThread.pas',
  tvXMLStatusManager in '..\XML\tvXMLStatusManager.pas',
  tvFormUsers in '..\UI\tvFormUsers.pas' { FormUsers },
  SQLite3 in '..\..\components\SQLite\SQLite3.pas',
  sqlite3udf in '..\..\components\SQLite\sqlite3udf.pas',
  SQLiteTable3 in '..\..\components\SQLite\SQLiteTable3.pas',
  tvDBManager in '..\Database\tvDBManager.pas',
  tvFormUserOptions in '..\UI\tvFormUserOptions.pas' { FormUserOptions },
  tvFormLogs in '..\UI\tvFormLogs.pas' { FormLogs },
  tvRectView in '..\UI\tvRectView.pas',
  tvFormLogin in '..\UI\tvFormLogin.pas' { FormLogin },
  tvOAuth in '..\Net\tvOAuth.pas',
  OAuth in '..\..\components\oauthdelphi\OAuth.pas',
  tvXMLStatusesTab in '..\XML\tvXMLStatusesTab.pas',
  tvFormAbout in '..\UI\tvFormAbout.pas' { FormAbout },
  tvJSON in '..\XML\tvJSON.pas',
  tvFormSpeechConfig in '..\UI\tvFormSpeechConfig.pas' { FormSpeechConfig },
  PerlRegEx in '..\..\components\TPerlRegEx\PerlRegEx.pas',
  pcre in '..\..\components\TPerlRegEx\pcre.pas',
  tvFormCaption in '..\UI\tvFormCaption.pas' { FormCaption },
  tvFormCaptionFontOptions in '..\UI\tvFormCaptionFontOptions.pas' { FormCaptionFontOptions },
  tvURLShortener in '..\Net\tvURLShortener.pas',
  tvXMLResponse in '..\XML\tvXMLResponse.pas',
  superobject in '..\..\components\superobject\superobject.pas',
  tvXMLUsersTab in '..\XML\tvXMLUsersTab.pas',
  GDIPAPI in '..\..\components\GDIPlus\GDIPAPI.pas',
  GDIPOBJ in '..\..\components\GDIPlus\GDIPOBJ.pas',
  GDIPUTIL in '..\..\components\GDIPlus\GDIPUTIL.pas',
  tvFormUserDetails in '..\UI\tvFormUserDetails.pas' {FormUserDetails},
  tvFormPinCode in '..\UI\tvFormPinCode.pas' {FormPinCode};

{$R *.res}
{$IFNDEF DEBUG}

const
  MutexName = 'TweetVoice';

var
  hMutex: THandle;
  hForm: THandle;
{$ENDIF}

begin
{$IFNDEF DEBUG}
  hMutex := CreateMutex(nil, False, MutexName);
  if WaitForSingleObject(hMutex, 0) = WAIT_TIMEOUT then
  begin
    hForm := FindWindow('TFormMainTweetVoice', nil);
    if (hForm <> 0) and (isWindowVisible(hForm)) then
    begin
      ShowWindowAsync(hForm, SW_RESTORE);
      SetForeGroundWindow(hForm);
    end;
  end
  else
  begin
{$ELSE}
    ReportMemoryLeaksOnShutdown := True; // ꂾ
{$ENDIF}
    Application.Initialize;
    Application.MainFormOnTaskbar := True;

    TUserConfig.LoadUserConfig;
    DBManager.Initialize;
    Application.Title := 'Tweet Voice';
    Application.CreateForm(TFormMainTweetVoice, FormMainTweetVoice);
  Application.CreateForm(TFormOptions, FormOptions);
  Application.CreateForm(TFormUsers, FormUsers);
  Application.CreateForm(TFormUserOptions, FormUserOptions);
  Application.CreateForm(TFormLogs, FormLogs);
  Application.CreateForm(TFormLogin, FormLogin);
  Application.CreateForm(TFormAbout, FormAbout);
  Application.CreateForm(TFormSpeechConfig, FormSpeechConfig);
  Application.CreateForm(TFormCaption, FormCaption);
  Application.CreateForm(TFormCaptionFontOptions, FormCaptionFontOptions);
  Application.CreateForm(TFormUserDetails, FormUserDetails);
  Application.CreateForm(TFormPinCode, FormPinCode);
  {$IFDEF DEBUG}
    // FormLogs.Show;
{$ENDIF}
    Application.Run;

    FormUsers.Close;
    FormCaption.Close;
{$IFNDEF DEBUG}
  end;
{$ENDIF}

end.
