unit tvFormSpeechConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, tvUserConfig, ComCtrls, StdCtrls;

type
  TFormSpeechConfig = class(TForm)
    ButtonCancel: TButton;
    ButtonOK: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ComboBoxLang: TComboBox;
    ComboBoxVoiceNames: TComboBox;
    TrackBarVolume: TTrackBar;
    TrackBarRate: TTrackBar;
    EditWaitingTime: TEdit;
    UpDownWaitingTime: TUpDown;
    LabelVolume: TLabel;
    LabelRate: TLabel;
    EditInitialSpeech: TEdit;
    Label6: TLabel;
    MemoPronounciations: TMemo;
    Label7: TLabel;
    Label9: TLabel;
    TrackBarMuteWaitingTime: TTrackBar;
    Label8: TLabel;
    EditRetweetSpeech: TEdit;
    procedure ButtonOKClick(Sender: TObject);
    procedure TrackBarVolumeChange(Sender: TObject);
    procedure TrackBarRateChange(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure GetFromUserConfig(ASpeechConfig: TSpeechConfig);
    procedure SetToUserConfig(ASpeechConfig: TSpeechConfig);
  end;

var
  FormSpeechConfig: TFormSpeechConfig;

implementation

uses tvSpeechThread;
{$R *.dfm}

procedure TFormSpeechConfig.ButtonOKClick(Sender: TObject);
begin
  Close;
  ModalResult := mrOK;
end;

procedure TFormSpeechConfig.GetFromUserConfig(ASpeechConfig: TSpeechConfig);
begin
  ComboBoxLang.Text := ASpeechConfig.Lang;
  ComboBoxVoiceNames.Text := ASpeechConfig.VoiceName;
  TrackBarVolume.Position := ASpeechConfig.Volume;
  TrackBarRate.Position := ASpeechConfig.Rate;
  TrackBarMuteWaitingTime.Position := ASpeechConfig.MuteWaitingTimeMSec;
  UpDownWaitingTime.Position := ASpeechConfig.WaitingTimeSec;
  LabelRate.Caption := IntToStr(TrackBarRate.Position);
  LabelVolume.Caption := IntToStr(TrackBarVolume.Position);
  EditInitialSpeech.Text := ASpeechConfig.InitialSpeech;
  EditRetweetSpeech.Text := ASpeechConfig.RetweetSpeech;
  ComboBoxVoiceNames.Items.Assign(TSpeechThread.VoiceNames);
  MemoPronounciations.Lines.Text := ASpeechConfig.Pronounciations;
end;

procedure TFormSpeechConfig.SetToUserConfig(ASpeechConfig: TSpeechConfig);
begin
  ASpeechConfig.Lang := ComboBoxLang.Text;
  ASpeechConfig.VoiceName := ComboBoxVoiceNames.Text;
  ASpeechConfig.Volume := TrackBarVolume.Position;
  ASpeechConfig.Rate := TrackBarRate.Position;
  ASpeechConfig.MuteWaitingTimeMSec := TrackBarMuteWaitingTime.Position;
  ASpeechConfig.WaitingTimeSec := UpDownWaitingTime.Position;
  ASpeechConfig.InitialSpeech := EditInitialSpeech.Text;
  ASpeechConfig.RetweetSpeech := EditRetweetSpeech.Text;
  ASpeechConfig.Pronounciations := MemoPronounciations.Lines.Text;
end;

procedure TFormSpeechConfig.TrackBarRateChange(Sender: TObject);
begin
  LabelRate.Caption := IntToStr(TrackBarRate.Position);
end;

procedure TFormSpeechConfig.TrackBarVolumeChange(Sender: TObject);
begin
  LabelVolume.Caption := IntToStr(TrackBarVolume.Position);
end;

end.
