unit tvFormUserOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, tvXMLBase, StrUtils;

type
  TFormUserOptions = class(TForm)
    LabelName: TLabel;
    LabelScreenName: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditNamePronounciation: TEdit;
    Label5: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ComboBoxTitle: TComboBox;
    procedure ButtonOKClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure SetFrom(AUser: TXMLUser);
    procedure SetTo(AUser: TXMLUser);
  end;

var
  FormUserOptions: TFormUserOptions;

implementation

{$R *.dfm}

procedure TFormUserOptions.ButtonOKClick(Sender: TObject);
begin
  Close;
  ModalResult := mrOk;
end;

procedure TFormUserOptions.SetFrom(AUser: TXMLUser);
var
  name, s: string;
  i, index: Integer;
begin
  LabelName.Caption := AUser.Name;
  LabelScreenName.Caption := '@' + AUser.ScreenName;

  name := AUser.NamePronounciation;
  if (name = '') then
  begin
    ComboBoxTitle.ItemIndex := 1;
  end
  else
  begin
    index := 0;
    for i := 1 to ComboBoxTitle.Items.Count - 1 do
    begin
      s := ComboBoxTitle.Items[i];
      if (StrUtils.EndsStr(s, name)) then
      begin
        name := StrUtils.LeftStr(name, Length(name) - Length(s));
        index := i;
        break;
      end;
    end;
    ComboBoxTitle.ItemIndex := index;
  end;
  EditNamePronounciation.Text := name;
end;

procedure TFormUserOptions.SetTo(AUser: TXMLUser);
begin
  AUser.NamePronounciation := EditNamePronounciation.Text + ComboBoxTitle.Text; ;
end;

end.
