unit tvXMLUsersTab;

interface

uses
  Windows, Classes, Generics.Collections, Graphics, ExtCtrls, SysUtils, utFunctions,
  tvUserConfig, tvXMLBase, Generics.Defaults, tvCommunicator, Forms, DateUtils, OAuth;

type
  TXMLUsersTab = class
  private
    FUsers: TList<TXMLUser>;
    FNoMoreUsers: Boolean;
  public
    TabID: Integer;
    TabType: TUsersTabType;
    // SinceID: Int64;
    LastUpdatedDateTime: TDateTime;
    UpdatingStatuses: Boolean;
    StatusPanelText: string;
    // BottomStatus: TXMLStatus;

    // function GetNextSpeechStatus: TXMLStatus;
    // function DisplayName: string;
    // function Url: string;
    // function AutoUpdateSec: Integer;
    // function CreateCommRequest(AForm: TForm; AOlder: Boolean): TCommRequest;
    function CanClose: Boolean;
    // function ContainsStatus(AID: Int64): Boolean;
    // function CreateConfig(ACollection: TCollection): TTabConfig;
    // procedure RequestStatuses(AForm: TForm; ACommunicator: TCommunicator);
    // procedure ReceiveStatuses(ARequest: TCommRequest);
    // procedure RequestStatusesOnTimer(AForm: TForm; ACommunicator: TCommunicator);
    // procedure RequestOlderStatuses(AForm: TForm; ACommunicator: TCommunicator);
    // procedure Sort;
    property Statuses: TList<TXMLUser>read FUsers;
    constructor Create; overload;
    constructor Create(ATabConfig: TUsersTabConfig); overload;
    destructor Destroy; override;
  end;

  TXMLUsersTabList = class
  private
    FTabIDSequence: Integer;
    FTabs: TList<TXMLUsersTab>;
    function GetTabs(i: Integer): TXMLUsersTab;
    procedure SetTabs(i: Integer; const Value: TXMLUsersTab);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Add(ATab: TXMLUsersTab);
    procedure Remove(ATab: TXMLUsersTab);
    procedure RequestUsersOnTimer(AForm: TForm; ACommunicator: TCommunicator);
    procedure RequestUsers(AForm: TForm; ACommunicator: TCommunicator);
    procedure ReceiveUsers(ARequest: TCommRequest);
    procedure ClearAllUsers;

    function UpdatingCount: Integer;
    function IndexOfTabID(ATabID: Integer): Integer;
    property Items: TList<TXMLUsersTab>read FTabs;
    property Tabs[i: Integer]: TXMLUsersTab read GetTabs write SetTabs; default;
  end;

implementation

{ TXMLUsersTab }

function TXMLUsersTab.CanClose: Boolean;
begin

end;

constructor TXMLUsersTab.Create;
begin

end;

constructor TXMLUsersTab.Create(ATabConfig: TUsersTabConfig);
begin
  //
end;

destructor TXMLUsersTab.Destroy;
begin

  inherited;
end;

{ TXMLUsersTabList }

procedure TXMLUsersTabList.Add(ATab: TXMLUsersTab);
begin
  FTabs.Add(ATab);
  Inc(FTabIDSequence);
  ATab.TabID := FTabIDSequence;
end;

procedure TXMLUsersTabList.ClearAllUsers;
var
  tab: TXMLUsersTab;
  //i: Integer;
begin
  //i := 0;
  for tab in FTabs do
  begin
    tab.Statuses.Clear;
    tab.FNoMoreUsers := false;
    //Inc(i);
  end;
end;

constructor TXMLUsersTabList.Create;
begin
  FTabIDSequence := 100;
  FTabs := TObjectList<TXMLUsersTab>.Create;
end;

destructor TXMLUsersTabList.Destroy;
begin
  FTabs.Free;
  inherited;
end;

function TXMLUsersTabList.GetTabs(i: Integer): TXMLUsersTab;
begin
  Assert(FTabs.Count > i);
  Result := FTabs[i];
end;

function TXMLUsersTabList.IndexOfTabID(ATabID: Integer): Integer;
var
  tab: TXMLUsersTab;
  index: Integer;
begin
  Result := -1;
  index := 0;
  for tab in FTabs do
  begin
    if (tab.TabID = ATabID) then
    begin
      Result := index;
      break;
    end;
    Inc(index);
  end;

end;

procedure TXMLUsersTabList.ReceiveUsers(ARequest: TCommRequest);
begin

end;

procedure TXMLUsersTabList.Remove(ATab: TXMLUsersTab);
begin
  FTabs.Remove(ATab);
end;

procedure TXMLUsersTabList.RequestUsers(AForm: TForm; ACommunicator: TCommunicator);
begin

end;

procedure TXMLUsersTabList.RequestUsersOnTimer(AForm: TForm; ACommunicator: TCommunicator);
begin

end;

procedure TXMLUsersTabList.SetTabs(i: Integer; const Value: TXMLUsersTab);
begin
  Assert(FTabs.Count > i);
  FTabs[i] := Value;
end;

function TXMLUsersTabList.UpdatingCount: Integer;
var
  tab: TXMLUsersTab;
begin
  Result := 0;
  for tab in FTabs do
  begin
    if (tab.UpdatingStatuses) then
    begin
      Inc(Result);
    end;
  end;

end;

end.
